

double * hist1(int * a, int sizea, int nbins) {

	int i, bw, max, min, numbins;
	double increment, limits[5], bins[5];
	
	max = -5;
	min = 10000;
	
	/* find the max row/col*/
	for(i=0; i<sizea; i++){
		if(a[i] > max){
			max = a[i];
		}
		if(a[i] < min){
			min = a[i];
		}
	}

	/* find the range of row/col and find limits of each bin */
	bw = max-min;
	increment = (double) bw / (double)nbins;
	
	/*xil_printf("bw = %d\nincrement = %f\n", bw, increment);*/
	
	for(i=0; i<nbins; i++){
		limits[i] = min + increment*(i+1);
		bins[i] = 0;
	}

	/* put all row/col values in appropriate bin */
	for(i=0; i<sizea; i++){
		if(a[i] <= limits[0]){
			bins[0] = bins[0] +1;
		}
		else if((a[i] > limits[0]) && (a[i] <= limits[1])){
			bins[1] = bins[1] +1;
		}
		else if((a[i] > limits[1]) && (a[i] <= limits[2])){
			bins[2] = bins[2] +1;
		}
		else if((a[i] > limits[2]) && (a[i] <= limits[3])){
			bins[3] = bins[3] +1;
		}
		else if((a[i] > limits[3]) && (a[i] <= limits[4])){
			bins[4] = bins[4] +1;
		}
	}
	
	/* return the bins */
	return bins;
}
