
#include <math.h>


double kl1 (double *p,double *pp, int sizep) {

	int i;
	double sump, sumpp, sumprob;
	double pd[5];
	double ppd[5];
	double subp[5];
	double prob[5];

	sump = 0;
	sumpp = 0;
	sumprob = 0;
	
	
	for(i=0; i<sizep; i++){
		p[i] = p[i]+0.0001;
		sump += p[i];
		pp[i] = pp[i]+0.0001;
		sumpp += pp[i];
	}


	for(i=0; i < sizep; i++) {
		p[i]= p[i]/sump;
		pp[i] = pp[i]/sumpp;
		pd[i] = log(p[i]);
		ppd[i] = log(pp[i]);
		subp[i] = ppd[i] - pd[i];
		prob[i] = p[i]*subp[i];
		sumprob += prob[i];
	}
	
	return sumprob;
	
}
