#include "header.h"


double smaller(int a[][100], int b[][100]) {
	int c, i, j, k, sizeC, d[2][100], sumD[2], e[100], mm, mn, maxe;
	double *testdat, testdat1[10], *imgdat, imgdat1[10], *xsig, *ysig;
	double jk[100], limits[21], bins[21], increment, *sig, sumsig;

	/*testdat = blah(a);*/
	
	/* number of black pixels found */
	sizeC=0;
	
	/* initialize to some impossible value */
	k= -1;
	for(i=0; i < 100; i++) {
		d[0][i] = -1;
		d[1][i] = -1;
		e[i]=-1;
	}
	
	/* go through the sample image row by row */
	/* find out the location of all black pixels */
	c =0;
	for(i=0; i < 100; i++) {
		for(j=0; j < 100; j++){

			if(!a[i][j]){
				d[0][c] = i;
				d[1][c] = j;
				c++;
			}
		}
	}

	/* number of black pixels found */
	sizeC= c;
	
	/* find sum of all row locations and col locations */	
	sumD[0] = 0;
	sumD[1] = 0;
	for(i=0; i < sizeC; i++) {
		sumD[0] = sumD[0] + d[0][i];
		sumD[1] = sumD[1] + d[1][i];
	}

	/* normalize all column and row locations */
		
	mm = sumD[0]/ sizeC;
	mn = sumD[1]/sizeC;

	/*xil_printf("mm = %d,  mn= %d \n", mm, mn);*/

	/* find the max value in row/col vector */
	maxe = -1;
	for(i=0; i < sizeC; i++) {
		e[i] = sqrt((d[0][i]-mm)*(d[0][i]-mm) + (d[1][i]-mn)*(d[1][i]-mn));
		if(e[i] > maxe){
			maxe = (float)e[i];

		} 
	}
	

	/*xil_printf("maxe = %d, %f\n", maxe, maxe);*/
	
	/* normalize each value according the the max
	 so the it lies between 0 and 1 */
	for(i=0; i < sizeC; i++) {
		jk[i]=(double) e[i] / (double) maxe;
		
	}
	/*xil_printf("\n(double)e[1] = %f, (double)maxe = %f, jk[1] = %f\n\n", (double)e[1], (double)maxe, ((double) e[i] / (double) maxe));
	xil_printf("\njk[0] = %f   jk[1] = %f\n", jk[0], jk[1]); */
	
	
	
	/*sig = hist2( e, sizeC, 21);*/

	/* now we are going to bin all vales into 21 bins
	   the bins are from 0 to 1 with 0.05 increment */
	
	increment = (double)0.05;
	
	/* find out the edges of all bins */
	for(i=0; i<21; i++){
		limits[i] = (double)increment*i;
		bins[i] = (double)0;
	}

	/* go through all normlized row/col values
	   bin them appropriately according to their value */
	for(i=0; i<21; i++){
		for(j=0; j < sizeC; j++){
			/*xil_printf("\n In hist2:  i = %d   j = %d",  i , j); 
			  xil_printf("\n a[i] %d",  a[i]);*/
			if(i==0){
				if(jk[j] <= (limits[i]+limits[i+1])/2){
					bins[i] = bins[i]+1;
				}
			}
			else if(i < 20 && jk[j] <= (limits[i] + limits[i+1])/2 && jk[j] > (limits[i]+limits[i-1])/2){
				bins[i] = bins[i]+1;
			}
			else if(i == 20 && jk[j] > (limits[i]+limits[i-1])/2){
				bins[i] = bins[i]+1;
			}
		}
	}
	
	/* find the sum of all values in each bins */
	sumsig = (double)0;
	for(i=0; i < 21; i++) {
			sumsig = bins[i] + sumsig;
	}

	/* normalize all bin values */
	for(i=0; i < 21; i++) {
		bins[i] = (double)(bins[i]/sumsig);
		/*xil_printf(" bins[i] = %f bins[i] = %f\n", bins[i], bins[i]);*/
	}
	
	/* testdat now has one profile of sample image */
	testdat = bins;
	
	
	/* now create another profile of rows and cols 
	   separately and save it in testdat1 */

	/*testdat1 = blah1(a);*/
	
	/* we will have 5 bins for rows and 5 for cols */
	i =5;
	/* create 5 bins from min row value to max row value */
	xsig = hist1(d[0], sizeC, i);
	/* create 5 bins from min col value to max col value */
	ysig = hist1(d[1], sizeC, i);
	
	/*xil_printf("\n%f %f %f %f %f\n", xsig[0], xsig[1], xsig[2], xsig[3],xsig[4]);
	xil_printf("\n%f %f %f %f %f\n", ysig[0], ysig[1], ysig[2], ysig[3],ysig[4]);*/

	/* save row/col bins in one vector */
	sumsig = 0;
	i =0;
	for(i=0; i < 5; i++) {
			testdat1[i] = xsig[i];
			testdat1[5+i] = ysig[i];
	}
	
	/* find sum of all bin values */
	for(i=0; i < 10; i++) {
		sumsig = testdat1[i] +sumsig;
	}

	/* normalize bin vales */
	for(i=0; i < 10; i++) {
		testdat1[i] = testdat1[i]/sumsig; 
	}
	
	
	/***************************************
	*
	* Now we will repeat a simalar procedure 
	* on image to be classified
	*
	*
	*****************************************/
	

	/* number of black pixels found */
	sizeC=0;

	/* initialize to some impossible value */
	k= -1;
	for(i=0; i < 100; i++) {
		d[0][i] = -1;
		d[1][i] = -1;
		e[i]=-1;
	}
	
	

	/* go through the image to be classified row by row */
	/* find out the location of all black pixels */
	c =0;
	for(i=0; i < 100; i++) {
		for(j=0; j < 100; j++){

			if(!b[i][j]){
				d[0][c] = i;
				d[1][c] = j;
				c++;
			}
		}
	}

	/* number of black pixels found */
	sizeC= c;
	
	/*xil_printf("sizeC = %d \n", sizeC);*/

	/* find sum of all row locations and col locations */	

	sumD[0] = 0;
	sumD[1] = 0;
	for(i=0; i < sizeC; i++) {
		sumD[0] = sumD[0] + d[0][i];
		sumD[1] = sumD[1] + d[1][i];
	}

	/* normalize all column and row locations */
	mm = sumD[0]/ sizeC;
	mn = sumD[1]/sizeC;

	/*xil_printf("mm = %d,  mn= %d \n", mm, mn);*/

	/* find the max value in row/col vector */

	maxe = -1;
	for(i=0; i < sizeC; i++) {
		e[i] = d[0][i] + d[1][i];
		if(e[i] > maxe){
			maxe = (float)e[i];

		} 
	}
	
	/*xil_printf("maxe = %d, %f\n", maxe, maxe);*/

	/* normalize each value according the the max
	 so the it lies between 0 and 1 */
	
	for(i=0; i < sizeC; i++) {
		jk[i]=(double) e[i] / (double) maxe;
		
	}
	/*xil_printf("\n(double)e[1] = %f, (double)maxe = %f, jk[1] = %f\n\n", (double)e[1], (double)maxe, ((double) e[i] / (double) maxe));
	xil_printf("\njk[0] = %f   jk[1] = %f\n", jk[0], jk[1]); */
	
	
	
	/*sig = hist2( e, sizeC, 21);*/

	/* now we are going to bin all vales into 21 bins
	   the bins are from 0 to 1 with 0.05 increment */
	
	increment = (double)0.05;

	/* find out edges of all bins */
	
	for(i=0; i<21; i++){
		limits[i] = (double)increment*i;
		bins[i] = (double)0;
	}
 
	/* go through all normlized row/col values
	   bin them appropriately according to their value */
	for(i=0; i<21; i++){
		for(j=0; j < sizeC; j++){
			/*xil_printf("\n In hist2:  i = %d   j = %d",  i , j); 
			//xil_printf("\n a[i] %d",  a[i]);*/
			if(i==0){
				if(jk[j] <= (limits[i]+limits[i+1])/2){
					bins[i] = bins[i]+1;
				}
			}

			else if(i < 20 && jk[j] <= (limits[i] + limits[i+1])/2 && jk[j] > (limits[i]+limits[i-1])/2){
				bins[i] = bins[i]+1;
			}
			else if(i == 20 && jk[j] > (limits[i]+limits[i-1])/2){
				bins[i] = bins[i]+1;
			}
		}
	}
	
	/* find sum of all bin values */
	sumsig = (double)0;
	for(i=0; i < 21; i++) {
			sumsig = bins[i] + sumsig;
	}

	/* normalize all bin values */
	for(i=0; i < 21; i++) {
		bins[i] = (double)(bins[i]/sumsig);
		/*xil_printf(" bins[i] = %f bins[i] = %f\n", bins[i], bins[i]);*/
	}
	
	/* imgdat now has one profile of image to be classified */
	imgdat = bins;
	

	/* now create another profile of rows and cols 
	   separately and save it in testdat1 */

	/* we will have 5 bins for rows and 5 for cols */
	i =5;
	/* create 5 bins from min row value to max row value */
	xsig = hist1(d[0], sizeC, i);
	/* create 5 bins from min col value to max col value */
	ysig = hist1(d[1], sizeC, i);
	
	/* save row/col bins in one vector */
	sumsig = 0;
	i =0;
	for(i=0; i < 5; i++) {
			imgdat1[i] = xsig[i];
			imgdat1[5+i] = ysig[i];
	}

	/* find sum of all bin values */
	for(i=0; i < 10; i++) {
		sumsig = imgdat1[i] +sumsig; 
	}

	/* normalize  all bin values */
	for(i=0; i < 10; i++) {
		imgdat1[i] = imgdat1[i]/sumsig; 
	}
	
	
	
	/************************************************************
	*
	* Now we have two profiles of each image we are going to 
	* compare each profile and return the result
	*
	*
	*************************************************************/
	
	return (kl2(testdat, imgdat, 21)+ kl1(testdat1, imgdat1, 5));

}
