function [div]=kl_mod(p,pp)

% add a small value to all locations to avoid log error 
p=(p+0.00001);
pp=(pp+0.00001);

% make sure all values are normalized all values
p=p/sum(p);
pp=pp/sum(pp);

% find the logarithmic difference (similar to ratio)
prob=p.*(log(pp)-log(p));

% make sure the prob is set to zero if images are identical
for i=1:size(prob,2)
  if (isnan(prob(i)))
    prob(i)=0;
  end
end

%return div
div=sum(prob);
