entity TEST_IDCT is
end;

library IEEE;
use IEEE.STD_LOGIC_1164.all;

library xil_idct_v1_00_a;
use xil_idct_v1_00_a.idct_core;


architecture BENCH of TEST_IDCT is

  component IDCT is
    port (
    Clk            : in  std_logic;
    Reset          : in  std_logic;
    Data_In        : in  std_logic_vector(31 downto 0);
    Data_In_Valid  : in  std_logic;
    Read_Data_In   : out std_logic;
    Data_Out_Full  : in  std_logic;
    Data_Out       : out std_logic_vector(31 downto 0);
    Data_Out_Valid : out std_logic);
  end component IDCT;

  signal Data_In, Data_Out: STD_LOGIC_VECTOR(31 downto 0);
  signal Clk, Reset, Data_In_Valid, Read_Data_In, Data_Out_Full, Data_Out_Valid: STD_LOGIC;

begin

  Clk <= "0", "1" after 100 NS, "0" after 200 NS, "1" after 300 NS, "0" after 400 NS,
    "1" after 500 NS, "0" after 600 NS, "1" after 700 NS;

  Data_In <= '00000000111111110000000011111111';
  Data_In_Valid <= '1';
  Data_Out_Full <= '1';
  

  i: IDCT port map (Clk, Reset, Data_In Data_In_Valid, Read_Data_In, 
    Data_Out_Full, Data_Out,Data_Out_Valid);

end BENCH;
